<template name="discussion">
	<div class="page-component discussion" id="discussion">
		<div class="course-page-component-header">
			<h4>
				<span class="fa-solid fa-comments fa-fw" aria-hidden="true"></span>&nbsp;
				{{i18n 'course.title.Discussion' 'Discussion'}}
			</h4>
		</div>
		{{#if Template.subscriptionsReady}}
			{{> post newPost}}
			{{#each p in posts}}
				<div class="discussion-conversation">
					{{> post p}}
				</div>
			{{/each}}
			{{#if limited}}
				<button class="btn btn-lg btn-add course-page-btn js-show-all-posts" type="button">
					<i class="fa-solid fa-chevron-down fa-fw" aria-hidden="true"></i>
					{{i18n 'course.discussions.showAllComment' 'Show all {NUM} comments' NUM=count}}
				</button>
			{{/if}}
		{{else}}
			{{> loadingRow}}
		{{/if}}
	</div>
</template>

<template name="post">
	{{#if editing}}
		{{> postEdit this}}
	{{else}}
		{{> postShow this}}
	{{/if}}
	{{#if notAllResponsesShown}}
		<button class="mt-3 btn btn-link p-0 toggle-all-responses js-show-previous-replies"
				type="button">
			{{i18n 'course.discussions.showPreviousReplies' 'Show all previous answers'}}
		</button>
	{{/if}}
	{{#each response in responses}}
		{{> post response}}
	{{/each}}
	{{#if allowResponse}}
		{{> post newResponse}}
	{{/if}}
</template>

<template name="postShow">
	{{#if new}}
		{{#if parentId}}
			<div class="discussion-reply">
				<button type="button" class="js-discussion-edit btn btn-add discussion-reply-btn"
						{{disabledIfBusy}}>
					{{#if busy 'saving'}}
						<span class="fa-solid fa-circle-notch fa-spin fa-fw"
							  aria-hidden="true"></span>
						{{i18n '_button.saving'}}
					{{else}}
						{{i18n 'course.discussion.comment_answer' 'Answer'}}
					{{/if}}
				</button>
			</div>
		{{else}}
			<button type="button" class="btn btn-lg btn-add course-page-btn js-discussion-edit"
					{{disabledIfBusy}}>
				{{#if busy 'saving'}}
					<span class="fa-solid fa-circle-notch fa-spin fa-fw"
						  aria-hidden="true"></span>&nbsp;
					{{i18n '_button.saving'}}
				{{else}}
					<span class="fa-solid fa-pencil fa-fw" aria-hidden="true"></span>&nbsp;
					{{i18n 'course.discussion.write_comment' 'Write a comment'}}
				{{/if}}
			</button>
		{{/if}}
	{{else}}
		<div {{postClasses}} id="comment{{_id}}">
			{{> discussionProfileIcon userId}}
			<div class="discussion-post-content">
				<div class="discussion-post-header">
					{{> discussionProfileLink userId}}
					<span class="discussion-post-header-sub">
						<span data-bs-toggle="tooltip"
							  data-bs-title="{{dateFormat time_created attr=true}}">
							{{fromNow time_created}}
						</span>
						{{#if notifyAll}}
							<i class="fa-solid fa-bell" aria-hidden="true" data-bs-toggle="tooltip"
							   data-bs-title="{{i18n 'course.discussion.allNotified' 'All co-learners notifed' attr=true}}"></i>
						{{/if}}
						{{#if hasBeenEdited}}
							-
							{{i18n 'course.discussion.lastUpdate' 'Last update'}}:
							<span data-bs-toggle="tooltip"
								  data-bs-title="{{dateFormat time_updated attr=true}}">
								{{fromNow time_updated}}
							</span>
						{{/if}}
					</span>
					<span class="discussion-buttons">
						{{#if mayEdit}}
							<button type="button" class="js-discussion-edit discussion-edit-btn">
								<span class="fa-solid fa-pen-to-square" aria-hidden="true"></span>
							</button>
						{{/if}}
						{{#if mayDelete}}
							{{> removeCommentDropdown}}
						{{/if}}
					</span>
				</div>
				<div class="discussion-post-body">
					{{#if this.title}}
						<h4 class="discussion-post-title">
							{{this.title}}
						</h4>
					{{/if}}
					<p>{{{text}}}</p>
				</div>
			</div>
		</div>
	{{/if}}
</template>

<template name="postEdit">
	<div class='{{postClass}} {{#if new}}{{#unless parentId}}discussion-post-new{{/unless}}{{/if}}'>
		{{> discussionProfileIcon userId}}
		<div class="discussion-edit-content">
			<form>
				<div class="discussion-edit-header">
					{{#if showUserId}}
						{{> discussionProfileLink userId}}
					{{else}}
						<strong>{{i18n 'discussion.anonymous' 'Anonymous'}}</strong>
					{{/if}}
					{{#unless new}}
						<span class="discussion-post-header-sub">
							<span data-bs-toggle="tooltip"
								  data-bs-title="{{dateFormat time_created attr=true}}">
								{{fromNow time_created}}
							</span>
							{{#if notifyAll}}
								<i class="fa-solid fa-bell" aria-hidden="true"
								   data-bs-toggle="tooltip"
								   data-bs-title="{{i18n 'course.discussion.allNotified' 'All co-learners notifed' attr=true}}"></i>
							{{/if}}
							{{#if hasBeenEdited}}
								-
								{{i18n 'course.discussion.lastUpdate' 'Last update'}}:
								<span data-bs-toggle="tooltip"
									  data-bs-title="{{dateFormat time_updated attr=true}}">
									{{fromNow time_updated}}
								</span>
							{{/if}}
						</span>
					{{/unless}}
				</div>
				<div class="discussion-edit-body">
					<div class="mb-3">
						<input class="js-post-title discussion-edit-title form-control form-control-lg"
							   type="text"
							   placeholder="{{i18n 'course.discussion.title_placeholder' 'Title' attr=true}} {{i18n '_inputField.optional' attr=true}}"
							   value="{{title}}" />
					</div>
					<div class="mb-3">
						{{> richtext class="js-post-text" text=text placeholder=richtextPlaceholder}}
					</div>
					{{#if new}}
						{{#if canNotifyAll}}
							<div class="form-check">
								<input class="form-check-input js-notify-all" type='checkbox'
									   {{notifyAllChecked}} value="" id="canNotifyAllCheck">
								<label class="form-check-label" for="canNotifyAllCheck">
									<i class="fa-solid fa-bell" aria-hidden="true"></i>
									{{i18n 'course.discussion.notifyAll' 'Notify all co-learners'}}
								</label>
							</div>
						{{/if}}
						<div class="form-check">
							<input class='form-check-input toggleAnonymous js-anon' type='checkbox'
								   {{anonChecked}} {{anonDisabled}} id="anonymousCheck" />
							<label class="form-check-label discussion-toggle-anonymous"
								   for="anonymousCheck">
								<i class="fa-solid fa-user-secret" aria-hidden="true"></i>
								{{i18n 'course.discussion.anon' 'Anonymous comment'}}
							</label>
						</div>
					{{/if}}
					<div class="form-actions">
						<button type="submit" class="btn btn-save discussion-save-btn"
								{{disabledIfBusy}} {{enableWhenValid}}>
							<span class="fa-solid fa-paper-plane fa-fw" aria-hidden="true"></span>
							{{#if new}}
								{{#if parentId}}
									{{i18n 'course.discussion.comment_btn.answer' 'Answer'}}
								{{else}}
									{{i18n 'course.discussion.comment_btn.write' 'Write'}}
								{{/if}}
							{{else}}
								{{i18n 'course.discussion.comment_btn.update' 'Update my comment'}}
							{{/if}}
						</button>
						{{> buttonCancel event="js-discussion-cancel"}}
					</div>
				</div>
			</form>
		</div>
	</div>
</template>

<template name="discussionProfileLink">
	{{#if this}}
		{{> profileLink userId=this}}
		{{contribution this}}
	{{else}}
		<span class="username">
			{{i18n 'comment.profileLink.anonymous' 'Anonymous'}}
		</span>
	{{/if}}
</template>

<template name="discussionProfileIcon">
	<div class="discussion-thumb">
		{{#if this}}
			<a href="{{pathFor 'userprofile' _id=this username=(username this)}}">
				{{> avatar class='discussion-profile-icon' userId=this}}
			</a>
		{{else}}
			{{> avatar class='discussion-profile-icon' color=0}}
		{{/if}}
	</div>
</template>

<template name="removeCommentDropdown">
	<span class="dropdown">
		<button type="button" class="discussion-delete-btn" aria-expanded="false"
				data-bs-toggle="dropdown">
			<span class="fa-solid fa-xmark" aria-hidden="true"></span>
		</button>
		<ul class="dropdown-menu dialog-dropdown right">
			<li class="dropdown-header">
				{{i18n 'comment.delete.header' 'Delete comment'}}
				<button type="button" class="btn-close"></button>
			</li>
			<li>
				<hr class="dropdown-divider">
			</li>
			<li class="dialog-dropdown-text">
				{{i18n 'comment.delete.confirm' 'Delete this comment?'}}
			</li>
			<li class="dialog-dropdown-btn">
				<button type="button" class="btn btn-remove js-delete-comment">
					{{i18n 'course.discussion.deleteCommentButton' 'Delete'}}
				</button>
			</li>
		</ul>
	</span>
</template>
